package com.eactive.eai.batch.job.jobItem.wis;

import java.io.BufferedInputStream;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.util.HashMap;
import java.util.Properties;

import com.eactive.eai.batch.common.FileUtil;
import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobHandle.JobProcessData;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;
import com.eactive.eai.batch.running.BatchOpenFileManager;
import com.eactive.eai.common.exception.ExceptionUtil;


public class SEND_LDB01_0320 extends DefaultTelegram implements TelegramService {

    private FileInputStream fin;
    private File file;
    private int BLOCK_NO;
    private int SEQUENCE_NO;
    private int REAL_BYTE;         //실 data byte수
    private int SEND_LENGTH;       //TCP/IP전문 송신 BYTES수로 "업무구분코드"이후의 송신할 전문 길이
    private int REAL_SEND_LENGTH;  //실제 송신할 전문의 총길이

    private Properties telegramInfo;
    private byte[] fileData;

    /**
     * 생성자
     */
    public SEND_LDB01_0320() {
        //DATA송신
    }

    /**
     * 전문조립
     */
    public boolean doExecute() {
        try {
            boolean result = setBlockAndSeqNO();
            if (!result) {
                return false;
            }
            result = calculateSendLength();
            if (!result) return false;

            //TCP/IP전문 송신 BYTES수로 "업무구분코드"이후의 송신할 전문 길이
            compileField(0, ""+SEND_LENGTH, this.al_FieldProps[0]);

            // 해당 Transaction을 기동하는 코드로 본 파일전송 업무는 “KFBFTP”문자를 사용한다.
//            compileField(1, telegramInfo.getProperty(TelegramKeys.TRANSACTION_CODE), this.al_FieldProps[1]);

            //업무구분코드 -업무구분을 위하여 Set하는 문자로 본 파일전송 업무에서는 “FTP”문자를 사용키로 한다.
            compileField(2, telegramInfo.getProperty(TelegramKeys.BIZ_GBN), this.al_FieldProps[2]);

            //대표기관코드 - 전문관련 금융기관을 나타내는 코드로서 금융기관 공동코드 (7자리)중 상위 3자리 금융기관 대표코드를 사용한다.
            // Ex) 국민: 004, 부산: 032, 농협: 011 등
            compileField(3, telegramInfo.getProperty(TelegramKeys.BANK_CODE), this.al_FieldProps[3]);

            //전문종별코드. 전문의 기능을 나타내는 구분코드로 전문종류별로 해당 전문코드를 Set하며 세부사항은 표준화 사항의 전문종별 코드를 참조한다.
            compileField(4, this.getFldTelegramType(), this.al_FieldProps[4]);

            //거래구분코드
            compileField(5, batchDoc.getBatchMsg().getHeader().getBizCode(), this.al_FieldProps[5]);

            //송수신 FLAG 전문을 발생시킨 기관을 나타내는 코드로 아래의 값중 해당코드를 Set한다.
            //“C”: 은행연합회에서 전문을 발생할 시
            //“B”: 은행에서 전문을 발생할 시
            compileField(6, telegramInfo.getProperty(TelegramKeys.TRA_FLAG_BANK), this.al_FieldProps[6]);

            //응답코드
            compileField(7, TelegramKeys.KFB_RET_CODE_SUCCESS, this.al_FieldProps[7]);

            //전송기준일자
            compileField(8, batchDoc.getBatchMsg().getHeader().getBaseDate(), this.al_FieldProps[8]);

            //업무별 Record Length -송수신을 하고자 하는 자료의 Record Length를 Set 한다.
            compileField(9, ""+batchDoc.getBatchMsg().getHeader().getRecLen(), this.al_FieldProps[9]);

            //송수신 업무 구분코드. 은행연합회를 기준으로 하여 해당전문이 송수신업무 중 어느 업무에 관련된 것인지를 구분하기 위한 코드로 아래 값 중 해당코드를 Set한다.
            //“S”: 파일 송신업무 관련 전문 (은행연합회 → 은행)
            //“R”: 파일 수신업무 관련 전문 (은행 → 은행연합회)
            compileField(10, getFldTrClass() , this.al_FieldProps[10]);

            //Block-NO
            compileField(11, ""+this.batchDoc.getBatchMsg().getBody().getBlockNum() , this.al_FieldProps[11]);

            //Sequence-NO
            compileField(12, ""+this.batchDoc.getBatchMsg().getBody().getSeqNum() , this.al_FieldProps[12]);

            //Record 수
            int recCnt = this.REAL_BYTE / batchDoc.getBatchMsg().getHeader().getRecLen();
            compileField(13, "" + recCnt, this.al_FieldProps[13]);

            int block_num = this.batchDoc.getBatchMsg().getBody().getBlockNum();
            if ( block_num > 0 && block_num < 9999) {
                batchDoc.getBatchMsg().getBody().setRecCnt( batchDoc.getBatchMsg().getBody().getRecCnt() + recCnt );
            }

            //<< 전문 완성

            return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI001";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
    }

    public int getInformalFieldSendData(int idx, byte[] data) {
        try {
            if (idx >= this.getFieldCount() ) {
                logger.debug("{}  getInformalFieldSendData> " +idx+ " is bigger than field count", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI011";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            if (data.length < REAL_BYTE) {
                logger.debug("{}  getInformalFieldSendData> InformalFieldSendData size is bigger than buffer size", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI014";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            if ( idx == 1 ){
            	int fldLen = getCalculatedLength(idx);
                System.arraycopy((telegramInfo.getProperty(TelegramKeys.TRANSACTION_CODE) + "         ").getBytes(), 0, data, 0, fldLen );
                // 로깅을 위해
                byte[] fieldData = new byte[fldLen];
                System.arraycopy(data, 0, fieldData, 0, fldLen);
                this.al_Field.set( idx, fieldData);
                return fldLen;
            }

            ByteArrayInputStream bin = new ByteArrayInputStream(fileData);
            bin.read(data, 0, REAL_BYTE);

            // 20060419 add by khs for 전송상태 확인
            long lnCurSize = batchDoc.getBatchMsg().getBody().getCurFileSize() + REAL_BYTE;
            batchDoc.getBatchMsg().getBody().setCurFileSize(lnCurSize);

            return REAL_BYTE;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI006";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return -1;
        }
    }

    public boolean doPostExecute() {
        try {
            if (!super.doPostExecute()) return false;

            if (this.getFldOpCode().equals("999") ){
                if (fin != null ) {
                    fin.close();
                    BatchOpenFileManager.getInstance().removeFile(batchDoc.getBatchMsg().getHeader().getUUID() );
                }
             }

            //DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<10; i++) { //은행연합회 전문의 헤더는 레코드 길이까지 임.
                byte[] barr = (byte[])this.al_Field.get(i);
                if ( barr[0] != '\0') {
                    baout.write((byte[])this.al_Field.get(i));
                }
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=10; i< al_Field.size(); i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));

            return true;

        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    public boolean doPreExecute() {
        try {
            if (!super.doPreExecute()) return false;
            telegramInfo = getTelegramInfo();
            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI003";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    /**
     * 실제 송신할 전문의 총길이를 리턴해준다.
     */
    public int getSendLength()
    {
        try {
            return REAL_SEND_LENGTH;  //실 DATA BYTE수
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI013";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return -1;
        }
    }

    /**
     * 비정형 필드에 대한 송신 길이를 계산해서 리턴해준다.
     *
     * 필드(idx)가 비정형 필드(XX)인지 점검하고 , 해당 필드에 대한 예상 길이를 계산하여 리턴하도록 한다
     *
     * 비정형 필드를 가지고 있는 개별 Telegram Class 에서 오버라이드 필요.
     */
    public int getCalculatedLength(int idx) {
        try {
            if (idx >= this.getFieldCount() ) {
                logger.debug("{} getCalculatedLength> parameter is bigger than field count", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI011";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            if (this.getFieldLength(idx).equalsIgnoreCase(TelegramService.FIELD_NO_LENGTH)) {
            	if ( idx == 1 ){
                    try {
                        return Integer.parseInt( telegramInfo.getProperty(TelegramKeys.TRCD_LEN) );
                    } catch (Exception e) {
                    	logger.info(e.getMessage(), e);
                        return 0;
                    }
            	}else{
                    return REAL_BYTE;
            	}
            } else {
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI012";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                logger.debug("{} getCalculatedLength> parameter is not FIELD_NO_LENGTH", logHeader);
                return -1;
            }
        }catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI005";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return -1;
        }
    }


    private boolean createFile ()
    {

        try {
            fin = BatchOpenFileManager.getInstance().getFile(batchDoc.getBatchMsg().getHeader().getUUID() );

            if ( fin == null) {
                String fileDir = batchDoc.getBatchMsg().getHeader().getFilePath();
                String fileNm  = batchDoc.getBatchMsg().getHeader().getRenamedFileName();

                if (fileDir.charAt(fileDir.length()-1) != File.separatorChar) {
                    fileDir = fileDir + File.separator;
                }

                String fileName = fileDir + fileNm;

                file = new File(fileName);
                if (!file.exists()) // 파일이 없으면 리턴 False
                {
                    logger.debug("{} the File["+fileDir+"/"+file.getName()+"] does not exist!!!", logHeader);
                    String[] msgArgs = new String[2];
                    msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                    msgArgs[1] = fileName;
                    String errCode = "BECEAIFJI022";
                    String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                    this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                    return false;
                }

                fin = new FileInputStream(file);
                BatchOpenFileManager.getInstance().addFile(batchDoc.getBatchMsg().getHeader().getUUID() , fileName, fin);
            }

            return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI028";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }

    }

    private boolean setBlockAndSeqNO ()
    {
        try {
            if (!createFile()) {
                logger.error("{}  file open failed", logHeader);
                return false;
            }

            int sequence_size = this.batchDoc.getBatchMsg().getHeader().getSequenceSize();
            int block_size    = this.batchDoc.getBatchMsg().getHeader().getBlockSize();
            int block_no      = this.batchDoc.getBatchMsg().getBody().getBlockNum();
            int seq_no        = this.batchDoc.getBatchMsg().getBody().getSeqNum();

            this.setConditionTxt("");

            // 파일에서 읽은 DATA를 추후 결번 재전송을 위해 메모리에 저장해 둔다. 2008.06.19 - 정동한
            JobProcessData job = JobProcessData.getInstance();
            String uuid = this.batchDoc.getBatchMsg().getHeader().getUUID();
            HashMap<String, Object> hm = (HashMap<String, Object>)job.getBatchStageData(uuid);

            @SuppressWarnings("unchecked")
            HashMap<Integer, byte[]> block_data = (HashMap<Integer, byte[]>) hm.get(JobProcessData.PROCDATA_BLOCKDATA);
            if (block_data == null) {
                block_data = new HashMap<Integer, byte[]>();
            }

            fileData = new byte[sequence_size + 1]; // 파일의 한 라인당 길이 + 개행문자 1바이트

            if (this.getFldOpCode().equals("000")) {
                fileData = new byte[batchDoc.getBatchMsg().getHeader().getRecLen()];
                byte[] fileLine = FileUtil.readLine(fin);
                System.arraycopy(fileLine, 0, fileData, 0, Math.min(fileLine.length, fileData.length));
                batchDoc.getBatchMsg().setFileHeader(new String(fileLine));
            }
            else if (this.getFldOpCode().equals("999")) {
                BLOCK_NO = 9999;
                SEQUENCE_NO = 999;

                fileData = new byte[batchDoc.getBatchMsg().getHeader().getRecLen()];
                byte[] fileLine = FileUtil.readLine(fin);
                System.arraycopy(fileLine, 0, fileData, 0, Math.min(fileLine.length, fileData.length));
                batchDoc.getBatchMsg().setFileTrailer(new String(fileLine));

            } else {
                if (block_no == 0 && seq_no == 0){
                    block_no = 1;
                    seq_no = 1;
                    BLOCK_NO = 1;
                    SEQUENCE_NO = 1;
                    this.setConditionTxt("");
                } else {
                    if (seq_no == block_size) { //한 블럭 송신 후 결번확인(0300) 이후 데이터 전송
                        this.BLOCK_NO = block_no+1;
                        this.SEQUENCE_NO = 1;
                        this.setConditionTxt("");

                    } else if (seq_no >= block_size-1) {    //블럭 크기에 도달하면 BLOCKEND 하여 다음 0620전문으로 넘어가게 함
                        this.BLOCK_NO = block_no;
                        this.SEQUENCE_NO = seq_no+1;
                        this.setConditionTxt(TelegramKeys.BLOCKEND);
                    } else {            //한 블럭내에 데이터 전송 반복이면
                        this.BLOCK_NO = block_no;
                        this.SEQUENCE_NO = seq_no+1;
                        this.setConditionTxt("");
                    }
                }

                // 한번에 블러킹 할 건수
                int seqCnt = ( batchDoc.getBatchMsg().getHeader().getSequenceSize() / batchDoc.getBatchMsg().getHeader().getRecLen() );
                // 남은 바이트 수
                long remainSize = batchDoc.getBatchMsg().getHeader().getFileSize() - batchDoc.getBatchMsg().getBody().getCurFileSize();
                // 남은 건수
                long remainCnt = remainSize / batchDoc.getBatchMsg().getHeader().getRecLen();

                if ( seqCnt < remainCnt - 1){
                    REAL_BYTE = seqCnt * batchDoc.getBatchMsg().getHeader().getRecLen();
                }else{
                    REAL_BYTE = (int)(remainCnt - 1) * batchDoc.getBatchMsg().getHeader().getRecLen();
                    this.setConditionTxt(TelegramKeys.BLOCKEND);
                }
                int readCnt = REAL_BYTE / batchDoc.getBatchMsg().getHeader().getRecLen();

                fileData = new byte[REAL_BYTE];
                for ( int inx = 0 ; inx < readCnt ; inx++){
                    byte[] fileLine = FileUtil.readLine(fin);
                    System.arraycopy( fileLine, 0, fileData, inx * batchDoc.getBatchMsg().getHeader().getRecLen(), batchDoc.getBatchMsg().getHeader().getRecLen());
                }

                block_data.put( new Integer(SEQUENCE_NO-1) ,  fileData);
                hm.put(JobProcessData.PROCDATA_BLOCKDATA, block_data);
            }

            REAL_BYTE = fileData.length;
            this.batchDoc.getBatchMsg().getBody().setBlockNum(BLOCK_NO);
            this.batchDoc.getBatchMsg().getBody().setSeqNum(SEQUENCE_NO);

            return true;
        } catch (Exception e ) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI029";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
    }

    private boolean calculateSendLength () {
        try {
            for (int i=2; i< this.al_Field.size()-1; i++) {
                byte[] aField = (byte[]) this.al_Field.get(i);
                SEND_LENGTH += aField.length;
            }
            SEND_LENGTH += getCalculatedLength(1);
            SEND_LENGTH += REAL_BYTE;
            REAL_SEND_LENGTH = SEND_LENGTH;
            REAL_SEND_LENGTH += ((byte[]) this.al_Field.get(0)).length;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI025";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
        return true;
    }

    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
        return super.getFieldValueString(4);
    }
    // 거래구분코드 필드값 리턴
    public String getTrClass()
    {
        return super.getFieldValueString(10);
    }
    //응답코드 필드값 리턴
    public String getResCode()
    {
        return super.getFieldValueString(7);
    }
    //업무관리코드 필드값 리턴
    public String getOpCode()
    {
        return super.getOpCode();
    }
}